package main

import (
	"go.wit.com/gui"
	"go.wit.com/lib/gadgets"
)

var me *mainType

func (b *mainType) Disable() {
	b.mainbox.Disable()
}

func (b *mainType) Enable() {
	b.mainbox.Enable()
}

// this app's variables
type mainType struct {
	myGui *gui.Node

	mainWindow *gadgets.BasicWindow

	// the main box. enable/disable this
	mainbox *gui.Node

	// the window from the /lib/gui/gowit package
	lw *gadgets.BasicWindow

	// our view of the repositories
	repos *repoWindow

	// #### Sorting options for the repolist
	autoHidePerfect  *gui.Node
	autoHideReadOnly *gui.Node

	// checkbox for --dry-run
	autoDryRun *gui.Node

	// checkbox to enable intermittent scanning
	// if checked, it will check all your repos for changes
	autoScanReposCB *gui.Node

	// what is being used as your home dir
	userHomePwd *gadgets.OneLiner

	// what is being used as ~/go/src
	goSrcPwd *gadgets.OneLiner

	// displays a summary of all the repos
	// has total dirty, total read-only
	// total patches, etc
	summary *patchSummary

	// when switch to user or devel branches, autocreate them
	autoCreateBranches *gui.Node

	// these hold the branches that the user can switch all
	// the repositories to them
	newBranch  *gui.Node
	setBranchB *gui.Node
}
